% script de objred, subrutina que evalua la aptitud de cada individuo
% as como el costo de cada uno de ellos, entendiendose por individuo 
% cada una de las redes, todas ellas posibles soluciones


function ObjVal=objred(Phen,NIND);
ObjVal=zeros(NIND,1);
for k=1:NIND
  D=Phen(k,:);
  
%%%%%%% RED  %%%%%%%
%NT:nmero de tuberas de la red, NN:nmero de nodos con carga desconocida 
%NS:nmero de nodos con carga desconocida H0:carga piezomtrica conocida (m), DEM:demanda en l/s, PMIN: presin mnima permitida en mca
%CU: costo por metro de presin desviado del valor de presin mnio, [$/mca]

NT=8; NN=6; 
PMIN=30; PMAX=50; VMIN=0.3; VMAX=5.0; CU=400000000; 

%Elevacin del terreno en m
%ELEV=load ('Elevacion.txt');
%Demanda en l/s
%DEM=load ('Demanda.txt');
%Nodos de entrada y salida
%N1=load ('Nodo1.txt');
%N2=load ('Nodo2.txt');
%Longitud de la tubera en m
LE=load ('Longitud.txt');
%Dimetro de la tubera en pulgadas
%D=load ('Diametro.txt');

%Clculo del costo de la red en funcin del dimetro y de la longitud de la tubera
C=zeros(NT,1);
for i=1:NT
   if D(i)==1,
      C(i)=2*LE(i);
   elseif D(i)==2,
      C(i)=5*LE(i);
   elseif D(i)==3,
      C(i)=8*LE(i);
   elseif D(i)==4,
      C(i)=11*LE(i);
   elseif D(i)==6,
      C(i)=16*LE(i);
   elseif D(i)==8,
      C(i)=23*LE(i);   
   elseif D(i)==10,
      C(i)=32*LE(i);   
   elseif D(i)==12,
      C(i)=50*LE(i);   
   elseif D(i)==14,
      C(i)=60*LE(i);   
   elseif D(i)==16,
      C(i)=90*LE(i);   
   elseif D(i)==18,
      C(i)=130*LE(i);   
   elseif D(i)==20,
      C(i)=170*LE(i);      
   elseif D(i)==22,
      C(i)=300*LE(i);   
   elseif D(i)==24,
      C(i)=550*LE(i);      
   end
end

Ci=sum(C);

%D
%pause,


%Convsersin del dimetro, pulgadas a milimetros
D=24.5*D;

%pause,
%Lee los datos de los almacenamientos
ALMA = load ('TANQUE.TXT');
%IDA  = ALMA(:,1);   %Identificador del almacenamiento
%CALMA= ALMA (:,2);  %Carga en los almacenamientos
%ALMA = ALMA';

%Lee datos de los nodos
NODE = load ('NODOS.TXT');
%IDN = NODE (:,1);   %Identificador del nodo
%ELEV = NODE (:,2);  %Elevacin en msnm
%DEM = NODE (:,3);   %Demanda en LPS


%Lee datos de las tuberas
PIPE=load ('TUBOS.TXT');
IDT=PIPE (:,1);     %Identificador de la tubera
N1=PIPE (:,2);      %Nodo inicial
N2=PIPE (:,3);      %Nodo final
L =PIPE (:,4);      %Long de la tubera en m
%DIAT=PIPE(:,5);     %Dimetro de la tuberea en mm
RUGO =PIPE (:,6);   %Rugosidad, puede ser en mm o sin unidades si se usa H-W
DIAT=D';


MM=[IDT, N1, N2, L, DIAT, RUGO];




%M=PIPE(NT,IDT)
%M=PIPE(NT,N1)
%M=PIPE(NT,N2)
%M=PIPE(NT,L)
%M=PIPE(NT,DIAT)
%M=PIPE(NT,RUGO)

%Lee datos de las coordenadas
%CORD=load ('COORDENADA.TXT');
%IDC=CORD (:,1);     %Identificador de coordenada de nudo
%CX=CORD (:,2);      %Coordenada X
%CY=CORD (:,3);      %Coordenada Y

%Genera el archivo de entrada para ser evaluado en EPANET
fp = fopen('entrada.txt', 'wt');

fprintf (fp,'[TITLE] \n');
fprintf (fp,'ALPEROVITS \n\n');

fprintf (fp,'[JUNCTIONS]\n');
fprintf (fp,';ID\t Elevacin\t Demanda\n');
fprintf (fp,';----------------------------------\n');
fprintf (fp,'%g\t %g\t %g\t\n',NODE');
fprintf (fp,'\n');

fprintf (fp,'[RESERVOIRS]\n');
fprintf (fp,';ID\tCarga\n');
fprintf (fp,';----------------------------------\n');
fprintf (fp,'%g\t %g\t\n',ALMA');
fprintf (fp,'\n');

fprintf (fp,'[PIPES]\n');
fprintf (fp,';ID\tNodo1\tNodo2\tLongitud\tDimetro\tRugosidad\n');
fprintf (fp,';-------------------------------------------------------------------\n');
fprintf (fp,'%g\t %g\t %g\t %g\t %g\t %g\t\n',MM');
fprintf (fp,'\n\n');


%fprintf (fp,'[COORDINATES]\n');
%fprintf (fp,';ID\t CX\t CY\n');
%fprintf (fp,';----------------------------------\n');
%fprintf (fp,'%g\t %g\t %g\t\n',CORD');
%fprintf (fp,'\n');


fprintf (fp,'[OPTIONS]\nUnits\tLPS\nHeadloss\tD-W\n\n');

fprintf (fp,'[REPORT]\nNodes\tAll\nLinks\tAll\n\n[END]\n\n');
    
fclose(fp);

dos('C:\ejemplo\epanet2d.exe entrada.txt salida.txt salida.bin');


%clc; 
%close all;

%Genera el archivo binario
fid=fopen('salida.bin','r');
A=fread(fid,inf,'float32');
T=size(A);
%fclose(fid);

%Obtiene presiones y velocidades para pasar a AG y evaluar aptitud de individuo

PP=T-(28+32*NT+4*(NN+1))/4;
PPP=PP-1;
PP1=PP-NN;


PRE=A(PP1:PPP);
%pause,

VV=T-(28+24*NT)/4;
VV1=VV-NT+1;
VEL=A(VV1:VV);


         
%%%%%%% FIN RED  %%%%%%%


%Clculo del costo de penalizacin debido a la desviacin con respecto a la presin mnima y a la presin mxima, 
%DP:desviacin de presin, mn y mx.
Cp=0;

for i=1:NN
    if PRE(i)<PMIN
      DPMIN(i)=PMIN-PRE(i);
      DPMAX(i)=0;
   elseif PRE(i)>PMAX
      DPMAX(i)=PRE(i)-PMAX;
      DPMIN(i)=0;
   else
      DPMIN(i)=0;
      DPMAX(i)=0;
   end %End de if P(i)<PMIN
end %End de for i=1:NN


%CALCULO DEL COSTO DE PENALIZACION DEBIDO A LA DESVIACION CON RESPECTO A LA VELOCIDAD MINIMA Y MAXIMA
Cpv=0;


for i=1:NN
    if VEL(i)<VMIN
      DVMIN(i)=VMIN-VEL(i);
      DVMAX(i)=0;
   elseif VEL(i)>VMAX
      DVMAX(i)=VEL(i)-VMAX;
      DVMIN(i)=0;
   else
      DVMIN(i)=0;
      DVMAX(i)=0;
   end %End de if P(i)<PMIN
end %End de for i=1:NN


%DPMIN
%DPMAX
%pause,
CP1=max(DPMIN);
CV1=max(DVMIN);
CP2=max(DPMAX);
CV2=max(DVMAX);
CP1=CP1*CU;
CP2=CP2*CU;
CV1=CV1*CU;
CV2=CV2*CU;
Cp=CP1+CP2+CV1+CV2;
fa=Ci+Cp;

%Asignacin de los valores de aptitud, y regreso a doruag para continuar el ciclo generacional
ObjVal(k)=fa;
ObjVal;
%pause,
end	%Fn de objred, primer for desde 1 hasta NIND

   
