% doruag ALPEROVITS
%
% 
%  
clear;
clc;
t=clock;
NIND = input('Nmero de individuos: ');	% Nmero de individuos por subpoblacin
MAXGEN = input('Nmero de Generaciones: ');	% Nmero mximo de generaciones
GGAP = 0.9;	% Nmero de individuos nuevos a crearse (probabilidad de copias)
NVAR = 34;	% Nmero de variables, equivale al numero de tubos
PRECI = 3;	% Precisin de la representacin binaria, acordarse de la base 2 y combinaciones posibles
Tabla = [12 16 20 24 30 40 12 16];

% Construccin del descriptor de campo, PRIMER CERO O UNO, 0 bin, 1 gray,
% e1 16 esta en funcion del conjunto de diametros disponibles
   FieldD = [rep([PRECI],[1, NVAR]); rep([1;8],[1, NVAR]); rep([1; 0; 1 ;1], [1, NVAR])];

% Generacin de poblacin inicial
   Chrom = crtbp(NIND, NVAR*PRECI);

% Resetea contadores
   Best = NaN*ones(MAXGEN,1);	% mejor individuo de la generacin actual
   gen = 0;			% contador de generaciones
   
% Evaluacin de la poblacin inicial
%ObjV = objred(bs2rv(Chrom,FieldD));
Phen=round((bs2rv(Chrom,FieldD)));
Phen=Tabla(Phen);
ObjV=objredalhw(Phen,NIND);

%Dibuja al mejor individuo y muestra en pantalla la convergencia
Best(gen+1) = min(ObjV);
plot((Best),'bo');xlabel('Generacin'); ylabel('Costo UM');
text(0.5,0.95,['Mejor = ', num2str(Best(gen+1))],'Units','normalized');   
drawnow;        

% Ciclo generacional
   while gen < MAXGEN,
       %gen

    % Asigna valores de aptitud a toda la poblacin
       FitnV = ranking(ObjV);

    % Selecciona individuos para la reproduccin
       SelCh = select('rws', Chrom, FitnV, GGAP);

    % Recombinacin de individuos seleccionados (crossover)
       SelCh = recombin('xovsp',SelCh,0.9);

    % Realiza la mutacin en la descendencia
       SelCh = mut(SelCh);

    % Evaluacin de hijos, llamada a la funcin objetivo
    %ObjVSel = objred(bs2rv(SelCh,FieldD));
    Phen=round(bs2rv(SelCh,FieldD));
    Phen=Tabla(Phen);
    ObjVSel=objredalhw(Phen,GGAP*NIND);

    % Reinsercin de hijos en la poblacin actual
       [Chrom ObjV]=reins(Chrom,SelCh,1,1,ObjV,ObjVSel);

    % Incrementa en 1 el contador generacional
       gen = gen+1;
              
     %Actualiza el dibujo de los mejores individuos
       Best(gen+1) = min(ObjV);
       plot((Best),'bo'); xlabel('Generacin'); ylabel('Costo UM');
       text(0.5,0.95,['Mejor = ', num2str(Best(gen+1))],'Units','normalized');
       drawnow;
    end 
    clc;
    fprintf ('Tiempo de clculo, en segundos'),T=etime(clock,t)
    
    %Mejor solucin
    [r s]=min(ObjV);
    CD=round(bs2rv(Chrom(s,:), FieldD));
    DIAM=Tabla(CD)'
    save Diametro.txt DIAM -ascii    
    % Fn de GA
